program TAB
!
  implicit none
!
  real*8, dimension (:,:,:), allocatable :: A, B
  real*8  :: h, xyz, maxA, maxB, minA, minB, PI
  integer :: n, i, j, k
  real*8  :: temps, t_cpu_0, t_cpu_1, t_cpu
  integer :: ir, t1, t2
!
  open (unit=100, file='donnees', status='old')
   read(100,*) n
  close (100)
!
  h = 1./float(n+1)
  PI = ACOS(-1.D0)
!
  allocate (A(n,n,n), B(n,n,n))
!
  ! Temps CPU de calcul initial
  call cpu_time(t_cpu_0)
!
  ! Temps elapsed de reference.
  call system_clock(count=t1, count_rate=ir)
!
  do k = 1, n
   do j = 1, n
    do i = 1, n
     xyz = i*j*k*h**3
     A(i,j,k) = 6*xyz*(1-xyz)
     B(i,j,k) = cos(PI*xyz)
    end do
   end do
  end do
!    
  do k = 1, n
   do j = 1, n
    do i = 1, n
     A(i,j,k) = A(i,j,k)+B(i,j,k)
     B(i,j,k) = A(i,j,k)*B(i,j,k)
    end do
   end do
  end do
!
  maxA = 0.
  minA = 0.
  maxB = 0.
  minB = 0.
  do k = 1, n
   do j = 1, n
    do i = 1, n
     maxA = max (maxA, A(i,j,k))
     minA = min (minA, A(i,j,k))
     maxB = max (maxB, B(i,j,k))
     minB = min (minB, B(i,j,k))
    end do
   end do
  end do
!
  ! Temps elapsed final
  call system_clock(count=t2, count_rate=ir)
  temps=(t2-t1)/float(ir)
!
  ! Temps CPU de calcul final
  call cpu_time(t_cpu_1)
  t_cpu = t_cpu_1 - t_cpu_0
!
  ! Impression du resultat.
  print '("maxA, minA, maxB, minB  : ",4(3X, D10.3),/  &
           &,3X,"Temps elapsed     : ",1D10.3," sec.",/ &
           &,3X,"Temps CPU         : ",1D10.3," sec.",//)',maxA, minA, maxB, minB, temps,t_cpu
!
  deallocate (A,B)
!
end program TAB
