#include "mpi.h"
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

double f(double x)
{
  return 4.0 / (1.0 + x*x);
}

double nint(double a){
        if (a>0){
                return (int)(a+0.5);
        }
        return (int)(a-0.5);
}

int main(int argc, char *argv[])

{

   int    ng, nl, nl1, nl2, i, nb_processus, rang;
   double xi, h, Pi_exact, Pi_calcule, Pi_loc, ecart;

   MPI::Init(argc,argv);
   rang=MPI::COMM_WORLD.Get_rank();
   nb_processus=MPI::COMM_WORLD.Get_size();

   if (rang == 0) {
	   ifstream fichier("donnees", ios::in);  
	   if(fichier){
	     fichier >> ng;  
	     fichier.close();
	   } 
   }

   MPI_Bcast (&ng, 1, MPI_INTEGER, 0, MPI_COMM_WORLD) ;

   Pi_exact = acos(-1.0);
   h = (double)1/(double)ng ;

   if (rang == 0)
   {
     printf ("Nombre d'intervalles global : %d\n", ng);
     printf ("Pas de discretisation : %.9f\n", h);
     printf ("PI exact : %.9f\n", Pi_exact);
   }

   nl1 = nint((double)ng/(double)nb_processus) ;
   nl2 = ng - (nl1*(nb_processus-1)) ;
   nl = nl1 ;
   if (rang==nb_processus-1) nl = nl2 ;

   Pi_loc = 0;
   for (i = 1; i <=nl; i++)
   {
     xi = h * ((double)i+(double)(nl1*rang)-0.5);
     Pi_loc = Pi_loc + f(xi);
   }
   Pi_loc = h * Pi_loc;

   printf ("Moi processus %d, le nombre d'intervalles de mon sous domaine est %d et mon PI local est egal a %.9f\n", rang, nl, Pi_loc) ;

   MPI_Reduce(&Pi_loc, &Pi_calcule, 1, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD);
	
   if (rang == 0){ 
     ecart = fabs(Pi_exact - Pi_calcule);
     printf ("| Pi_exact - Pi_calcule | = %.9e\n", ecart);
   }
	
    MPI::Finalize ();

}
