from mpi4py import MPI
import numpy as np

def nint(a):
   if (a>0):
     return (int)(a+0.5);
   return (int)(a-0.5);


comm = MPI.COMM_WORLD
rang = comm.Get_rank ()
nb_processus = comm.Get_size ()

if (rang==0) :
  mon_fichier = open("donnees", "r")
  contenu = mon_fichier.read()
  mon_fichier.close()
  ng = int(contenu)
else :
  ng = None
    
ng=comm.bcast(ng, root=0)

h = 1./ng
nl1 = nint(float(ng)/float(nb_processus))
nl2 = ng - (nl1*(nb_processus-1))
nl = nl1
if (rang==nb_processus-1) :
  nl = nl2

p = 1+(nl1*rang)
q = nl+(nl1*rang)
pq = q-p+1

A = np.zeros((nl,nl))
for i in range (0,nl) : 
  for j in range (0,nl) : 
     xy= (i+p)*(j+p)*(h*h)
     A[i,j]=xy
   
traceloc = np.zeros(1)
traceglob = np.zeros(1)

for i in range (0,nl) : 
   traceloc = traceloc + A[i,i] ;
print ("Moi processus de rang" ,rang, ", j'ai une sous-matrice carree de taille " ,pq, " et ma trace locale est egale a %.9f\n" % traceloc,)

comm.Reduce(traceloc, traceglob, op=MPI.SUM, root=0)

if (rang == 0) :
  print ("Moi processus de rang" ,rang, ", je recupere la trace globale de la matrice carree de taille " ,ng, " et cette trace est egale a %.9f\n" % traceglob,)
